<template>
    <form @click="(e) => { handleGeneralClick(e) }" class="register-form">
        <SpinnerComponent v-if="spinner" />
        <br />
        <h3>Rejestracja konta o adresie email: {{ email }}</h3>
        <v-btn v-if="isLargeScreen || isMediumScreen" @click="$router.push({ path: '/' })" class="back ma-2" dark>
            <v-icon dark left>
                mdi-arrow-left
            </v-icon>Powrót
        </v-btn>
        <v-btn v-if="!isLargeScreen && !isMediumScreen" @click="$router.push({ path: '/' })" class="back ma-2 right" dark>
            <v-icon dark left>
                mdi-arrow-left
            </v-icon>
        </v-btn>
        <br />
        <v-text-field v-model="nick" :error-messages="nickErrors" label="Nick" required @input="$v.nick.$touch()"
            @blur="$v.nick.$touch()"></v-text-field>
        <v-text-field v-model="password" :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
            :type="show1 ? 'text' : 'password'" name="input-10-1" label="ustaw hasło"
            hint="hasło musi być wystarczająco złożone" counter @click:append="show1 = !show1"></v-text-field>
        <v-progress-linear style="width:200px" :color="metterColor" height="20" width="200" :value="metterValue"
            striped></v-progress-linear>
        <v-text-field v-model="repeatPassword" :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
            :type="show1 ? 'text' : 'password'" name="input-10-1" label="powtórz hasło" counter
            @click:append="show1 = !show1"></v-text-field>
        <AutocompleteCity @city="setCity" />
        Wybierz zdjęcie profilowe
        <UploadImage ref="uploader" :number="1" :change="changeUpload" @formData="(data) => { handleChangeImage(data) }"
            @error="() => { errors.push('Błąd serwera') }" style="margin: 20px;" />
        <v-btn @click="() => this.submit()" class="glass button" block elevation="2" text>Zapisz</v-btn>
        <v-snackbar v-model="showErrors" multiline>
            <div v-for="(el, index) in errors" :key="index">
                {{ el }}
            </div>
            <template v-slot:action="{ attrs }">
                <v-btn color="warning" text v-bind="attrs" @click="() => { showErrors = false }">
                    Zamknij
                </v-btn>
            </template>
        </v-snackbar>
        <ClientOnly>
            <WindowComponent v-if="successfullRegistration"
            @close="$router.push({path: '/'})"
            header="Witamy w serwisie randkowym 'Ku Sobie'"
            content="Rejestracja przebiegła pomyślnie. Od tej pory możesz zawierać nowe znajomości. Życzymy mile spędzonych chwil."/>            
        </ClientOnly>
    </form>
</template>
<script>
import { useMediaQuery } from "@vueuse/core";
import { validationMixin } from 'vuelidate'
import { required, maxLength, email } from 'vuelidate/lib/validators'
import passwordMixin from '../mixins/password'

const isLargeScreen = useMediaQuery("(min-width: 950px)");
const isMediumScreen = useMediaQuery("(min-width: 751px)");
export default {
    name: 'RegisterPage',

    mixins: [validationMixin, passwordMixin],

    validations: {
        nick: { required, maxLength: maxLength(10) },
        email: { required, email },
        select: { required },
        checkbox: {
            checked(val) {
                return val
            },
        },
    },

    mounted() {
        this.spinner = false;
    },

    data() {
        return {
            spinner: true,
            formData: null,
            nick: '',
            email: this.$store.state.user.email,
            city: null,
            checkbox: false,
            successfullRegistration: false,
            show1: false,
            changeUpload: {
                changed: false
            },
            rules: {
                required: value => !!value || 'Required.',
                min: v => v.length >= 8 || 'Min 8 characters',
                emailMatch: () => (`The email and password you entered don't match`),
            },

            requirements: {
                email: true,
                nick: false,
                passwordComplexity: false,
                passwordsEqual: true
            },
            errors: [],
            showErrors: false.
            isLargeScreen,
            isMediumScreen
        }
    },

    computed: {

        citiesErrors() {
            const errors = []
            if (!this.$v.select.$dirty) return errors
            !this.$v.select.required && errors.push('Item is required')
            return errors
        },

        nickErrors() {
            const errors = []
            if (!this.$v.nick.$dirty) return errors
            //!this.$v.nick.maxLength && errors.push('Nick musi mieć co najmniej 10 znaków')
            !this.$v.nick.required && errors.push('Nick jest wymagany')
            return errors
        },

        passwordErrors() {
            const errors = []
            if (!this.$v.email.$dirty) return errors
            !this.$v.email.email && errors.push('Must be valid e-mail')
            !this.$v.email.required && errors.push('E-mail is required')
            return errors
        },

        errorsSum() {
            return this.errors.length > 0
        }
    },

    methods: {
        
        handleGeneralClick(e) {
            if (e.target.getAttribute('id') !== 'input-98') {
                this.$bus.$emit('no-cities');
            }
        },

        handleChangeImage(data) {

            this.formData = data
        },

        async submit() {
            this.errors = [];
            this.showErrors = false;
            if (!this.passwordComplexity) {
                this.errors.push('Za słabe hasło.')
            }
            if (!this.passwordsEqual) {
                this.errors.push('Hasła się różnią.')
            }
            if (!/^[A-Za-z0-9ĄĘĆÓŁŃÓŚŹŻąęćółńśźż_]+$/.test(this.nick)) {
                this.errors.push('Nick musi być niepustym wyrażniem złożonym z liter, cyfr i podkreślnika')
            }
            if (!this.city) {
                this.errors.push('Miejscowość musi zostać wybrana z listy')
            }

            const { data } = await this.$axios(this.$config.serverUrl+'/user/get-by-nick',
            {params: {nick: this.nick}});
            if(data.status==='User exists') {
                this.errors = ['Nick jest zajęty'];
            }

            if (this.errors.length > 0) {
                this.showErrors = true;
                return;
            }

            this.$axios.post(this.$config.serverUrl + '/user/register', {
                email: this.$store.state.user.email, nick: this.nick,
                password: this.password, city: this.city,
                profileImage: this.$refs.uploader.$refs.uploader.images[0]?.path
            }).then(({ data }) => {
                const { status, message } = data;
                if (status === 'OK') {
                    this.successfullRegistration = true;
                    setTimeout(() => {
                        this.$router.push({ path: '/' })
                    }, 10000)
                }
                if (status === 'NOT OK' && message === 'user exists') {
                    this.errors = ['Wybrany użytkownik jest już zarejestrowany'];
                    this.showErrors = true;
                }

                if(status == 'NOT OK' && message == 'Profile image too large') {
                    this.errors = ['Dopuszczalna wielkość zdjęcia profilowego to 15MB. Spróbuj je skadrować lub/i skompresować'];
                    this.showErrors = true;
                }
            }).catch(error => {
                this.errors = ['Wystąpił błąd po stronie serwera. Spróbuj ponownie później'];
                this.showErrors = true;
            })

        },

        clear() {
            this.$v.$reset()
            this.name = ''
            this.email = ''
            this.select = null
            this.checkbox = false
        },

        setCity(city) {
            this.city = city;
        },

        getCities() {
            console.log('getCities')
            if (this.city.length < 4) return;
            this.$axios.post(this.$config.serverUrl + '/city/', { prefix: this.city }).then(data => {

            })
        },


    },
}
</script>
<style scoped lang="scss">
.register-form {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    .back {
        position: fixed;
        right: 70px;
        top: 112px;
        &.right {
            right: 11px;
            width: 64px;
        }
    }
    .button {
        min-width: unset !important;
        width: 87px;
        margin-top: 5px;
    }
    .container {
        display: flex;
    }
}
</style>